/*
 * xkeymacs substitute for X11/Linux
 * Copyright 2011 (C) Takeshi Yashiro <yashiromann@nifty.com>
 *
 * window.h: window system
 */

#ifndef _DEFINE_H_X11KEYMACS_WINDOW_
#define _DEFINE_H_X11KEYMACS_WINDOW_

#include <X11/Xlib.h>
#include <string>

/*!
 * Window system (X11)
 */
class WindowSystem
{
public:
    ~WindowSystem();
    static WindowSystem* getInstance();
    std::string getFocusedWindowTitle();
    bool isValid() const {
        return m_display != 0;
    }

private:
    WindowSystem();
    static WindowSystem* m_instance;

    static int errorHandler(Display* display, XErrorEvent* err);

    Display* m_display;
    bool m_xerr;
};

#endif /* _DEFINE_H_X11KEYMACS_WINDOW_ */
